/*
 *        spChunk.h
 *        
 *        **** UNOFFICIAL VERSION, DON'T USE THIS API ****
 */

#ifndef __SPCHUNK_H
#define __SPCHUNK_H

#include <stdio.h>
#include <sp/spWave.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SP_SUPPORT_64BIT_INT
#define spChunkSize spLong64
#else
#define spChunkSize spFileOffset
#endif

#define SP_CHUNK_INFO_OPTION_FULLBOX_MASK (1)
#define SP_CHUNK_INFO_OPTION_REWRITE_MASK (1<<1)
#define SP_CHUNK_INFO_OPTION_PAUSE_BEFORE_WRITE_MASK (1<<2)
#define SP_CHUNK_INFO_OPTION_PAUSE_AFTER_WRITE_MASK (1<<3)
#define SP_CHUNK_INFO_OPTION_WRITE_ZEROS_MASK (1<<4)
#define SP_CHUNK_INFO_OPTION_PAUSE_BEFORE_READ_MASK (1<<5)
#define SP_CHUNK_INFO_OPTION_PAUSE_AFTER_READ_MASK (1<<6)
#define SP_CHUNK_INFO_OPTION_MARGIN_CHUNK_MASK (1<<7)
#define SP_CHUNK_INFO_OPTION_ACCEPT_ZERO_TYPE_MASK (1<<8)

#define SP_CHUNK_INFO_OPTION_USER_MASK_OFFSET 16
    
typedef struct _spChunk spChunk;
    
typedef spChunkSize (*spChunkUpdateFunc)(spChunk *chunk, void *data);
    
typedef struct _spChunkHeader {
    char type[4];

    char dummy[44];
} spChunkHeader;
    
struct _spChunk {
    struct _spChunk *parent;
    struct _spChunk *child;
    
    struct _spChunk *prev;
    struct _spChunk *next;

    spFileOffset offset;
    
    spChunkHeader header;
};

extern spChunk *spFindChunk(spChunk *chunk, const char *type, const char *parent_type);
extern spChunk *spFindChildChunk(spChunk *top, const char *type, const char *parent_type);
    
#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPCHUNK_H */
