/*
 *        spID3.h
 *        
 *        **** UNOFFICIAL VERSION, DON'T USE THIS API ****
 */

#ifndef __SPID3_H
#define __SPID3_H

#include <sp/spChunk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define spID3FrameSize spChunkSize

#define SP_ID3_CHUNK_INFO_OPTION_TEXT_MASK (1<<(SP_CHUNK_INFO_OPTION_USER_MASK_OFFSET))
#define SP_ID3_CHUNK_INFO_OPTION_DESC_MASK (1<<(SP_CHUNK_INFO_OPTION_USER_MASK_OFFSET+1))
#define SP_ID3_CHUNK_INFO_OPTION_LANG_MASK (1<<(SP_CHUNK_INFO_OPTION_USER_MASK_OFFSET+2))
#define SP_ID3_CHUNK_INFO_OPTION_DESC_TEXT_MASK (SP_ID3_CHUNK_INFO_OPTION_DESC_MASK|SP_ID3_CHUNK_INFO_OPTION_TEXT_MASK)
#define SP_ID3_CHUNK_INFO_OPTION_LANG_TEXT_MASK (SP_ID3_CHUNK_INFO_OPTION_LANG_MASK|SP_ID3_CHUNK_INFO_OPTION_DESC_TEXT_MASK)
    
#define SP_ID3_FRAME_TYPE_ALBUM_V2_2 "TAL"
#define SP_ID3_FRAME_TYPE_ALBUM_V2_3 "TALB"
#define SP_ID3_FRAME_TYPE_ALBUM SP_ID3_FRAME_TYPE_ALBUM_V2_3
#define SP_ID3_FRAME_TYPE_COMPOSER_V2_2 "TCM"
#define SP_ID3_FRAME_TYPE_COMPOSER_V2_3 "TCOM"
#define SP_ID3_FRAME_TYPE_COMPOSER SP_ID3_FRAME_TYPE_COMPOSER_V2_3
#define SP_ID3_FRAME_TYPE_LYRICIST_V2_2 "TXT"
#define SP_ID3_FRAME_TYPE_LYRICIST_V2_3 "TEXT"
#define SP_ID3_FRAME_TYPE_LYRICIST SP_ID3_FRAME_TYPE_LYRICIST_V2_3
#define SP_ID3_FRAME_TYPE_COPYRIGHT_V2_2 "TCR"
#define SP_ID3_FRAME_TYPE_COPYRIGHT_V2_3 "TCOP"
#define SP_ID3_FRAME_TYPE_COPYRIGHT SP_ID3_FRAME_TYPE_COPYRIGHT_V2_3
#define SP_ID3_FRAME_TYPE_TRACK_V2_2 "TRK"
#define SP_ID3_FRAME_TYPE_TRACK_V2_3 "TRCK"
#define SP_ID3_FRAME_TYPE_TRACK SP_ID3_FRAME_TYPE_TRACK_V2_3
#define SP_ID3_FRAME_TYPE_DISC_V2_2 "TPA"
#define SP_ID3_FRAME_TYPE_DISC_V2_3 "TPOS"
#define SP_ID3_FRAME_TYPE_DISC SP_ID3_FRAME_TYPE_DISC_V2_3
#define SP_ID3_FRAME_TYPE_TITLE_V2_2 "TT2"
#define SP_ID3_FRAME_TYPE_TITLE_V2_3 "TIT2"
#define SP_ID3_FRAME_TYPE_TITLE SP_ID3_FRAME_TYPE_TITLE_V2_3
#define SP_ID3_FRAME_TYPE_ARTIST_V2_2 "TP1"
#define SP_ID3_FRAME_TYPE_ARTIST_V2_3 "TPE1"
#define SP_ID3_FRAME_TYPE_ARTIST SP_ID3_FRAME_TYPE_ARTIST_V2_3
#define SP_ID3_FRAME_TYPE_ALBUM_ARTIST_V2_2 "TP2"
#define SP_ID3_FRAME_TYPE_ALBUM_ARTIST_V2_3 "TPE2"
#define SP_ID3_FRAME_TYPE_ALBUM_ARTIST SP_ID3_FRAME_TYPE_ALBUM_ARTIST_V2_3
#define SP_ID3_FRAME_TYPE_GENRE_V2_2 "TCO"
#define SP_ID3_FRAME_TYPE_GENRE_V2_3 "TCON"
#define SP_ID3_FRAME_TYPE_GENRE SP_ID3_FRAME_TYPE_GENRE_V2_3
#define SP_ID3_FRAME_TYPE_SOFTWARE_V2_2 "TEN"
#define SP_ID3_FRAME_TYPE_SOFTWARE_V2_3 "TENC"
#define SP_ID3_FRAME_TYPE_SOFTWARE SP_ID3_FRAME_TYPE_SOFTWARE_V2_3
#define SP_ID3_FRAME_TYPE_TEMPO_V2_2 "TBP"
#define SP_ID3_FRAME_TYPE_TEMPO_V2_3 "TBPM"
#define SP_ID3_FRAME_TYPE_TEMPO SP_ID3_FRAME_TYPE_TEMPO_V2_3 
#define SP_ID3_FRAME_TYPE_COMMENT_V2_2 "COM"
#define SP_ID3_FRAME_TYPE_COMMENT_V2_3 "COMM"
#define SP_ID3_FRAME_TYPE_COMMENT SP_ID3_FRAME_TYPE_COMMENT_V2_3
#define SP_ID3_FRAME_TYPE_PUBLISHER_V2_2 "TPB"
#define SP_ID3_FRAME_TYPE_PUBLISHER_V2_3 "TPUB"
#define SP_ID3_FRAME_TYPE_PUBLISHER SP_ID3_FRAME_TYPE_PUBLISHER_V2_3
    
#define SP_ID3_FRAME_TYPE_RELEASE_V2_2 "TYE"
#define SP_ID3_FRAME_TYPE_RELEASE_V2_3 "TYER"
#define SP_ID3_FRAME_TYPE_RELEASE_V2_4 "TDRC"
#define SP_ID3_FRAME_TYPE_RELEASE SP_ID3_FRAME_TYPE_RELEASE_V2_4    
    
#define SP_ID3_FRAME_TYPE_ISRC_V2_3 "TSRC"
#define SP_ID3_FRAME_TYPE_ISRC SP_ID3_FRAME_TYPE_ISRC_V2_3
    
#define SP_ID3_HEADER_FLAG_UNSYNCHRONISATION_MASK 0x80
#define SP_ID3_HEADER_FLAG_V2_2_COMPRESSION_MASK 0x40
#define SP_ID3_HEADER_FLAG_EXTENDED_MASK 0x40
#define SP_ID3_HEADER_FLAG_EXPERIMENTAL_MASK 0x20
#define SP_ID3_HEADER_FLAG_V2_4_FOOTERL_MASK 0x10

#define SP_ID3_HEADER_EXTRA_FLAG_V2_3_CRC_MASK 0x8000

#define SP_ID3_HEADER_EXTRA_FLAG_V2_4_TAG_UPDATE_MASK 0x40
#define SP_ID3_HEADER_EXTRA_FLAG_V2_4_CRC_MASK 0x20
#define SP_ID3_HEADER_EXTRA_FLAG_V2_4_TAG_RESTRICTIONS_MASK 0x10

#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_SIZE_1MB 0x0
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_SIZE_128KB 0x40
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_SIZE_40KB 0x80
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_SIZE_4KB 0xc0

#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_TEXT_ENCODING_NONE 0x0
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_TEXT_ENCODING_ISO8859_1_OR_UTF8 0x20

#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_TEXT_SIZE_NONE 0x0
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_TEXT_SIZE_1024 0x8
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_TEXT_SIZE_128 0x10
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_TEXT_SIZE_30 0x18

#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_IMAGE_ENCODING_NONE 0x0
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_IMAGE_ENCODING_PNG_OR_JPEG 0x4

#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_IMAGE_SIZE_NONE 0x0
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_IMAGE_SIZE_UP_TO_256x256 0x1
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_IMAGE_SIZE_UP_TO_64x64 0x2
#define SP_ID3_HEADER_EXTRA_TAG_RESTRICTIONS_IMAGE_SIZE_EXACTLY_64x64 0x3

#define SP_ID3_FRAME_HEADER_FLAG1_V2_3_TAG_ALTER_MASK 0x80
#define SP_ID3_FRAME_HEADER_FLAG1_V2_3_FILE_ALTER_MASK 0x40
#define SP_ID3_FRAME_HEADER_FLAG1_V2_3_READ_ONLY_MASK 0x20

#define SP_ID3_FRAME_HEADER_FLAG2_V2_3_COMPRESSION_MASK 0x80
#define SP_ID3_FRAME_HEADER_FLAG2_V2_3_ENCRIPTION_MASK 0x40
#define SP_ID3_FRAME_HEADER_FLAG2_V2_3_GROUPING_MASK 0x20

#define SP_ID3_FRAME_HEADER_FLAG1_V2_4_TAG_ALTER_MASK 0x40
#define SP_ID3_FRAME_HEADER_FLAG1_V2_4_FILE_ALTER_MASK 0x20
#define SP_ID3_FRAME_HEADER_FLAG1_V2_4_READ_ONLY_MASK 0x10

#define SP_ID3_FRAME_HEADER_FLAG2_V2_4_GROUPING_MASK 0x40
#define SP_ID3_FRAME_HEADER_FLAG2_V2_4_COMPRESSION_MASK 0x8
#define SP_ID3_FRAME_HEADER_FLAG2_V2_4_ENCRIPTION_MASK 0x4
#define SP_ID3_FRAME_HEADER_FLAG2_V2_4_UNSYNCHRONISATION_MASK 0x2
#define SP_ID3_FRAME_HEADER_FLAG2_V2_4_DATA_LENGTH_MASK 0x1

typedef struct _spID3HeaderExtra_V2_3 {
    unsigned long size;
    short flag;
    unsigned long padding_size;
    unsigned long crc;
} spID3HeaderExtra_V2_3;

typedef struct _spID3HeaderExtra_V2_4 {
    unsigned long size;
    unsigned char flag_length;
    unsigned char flag;
    unsigned long crc;
    unsigned char restrictions;
} spID3HeaderExtra_V2_4;

typedef struct _spID3FrameHeaderExtra_V2_3 {
    unsigned long decompressed_size;
    unsigned char encryption_method;
    unsigned char group_id;
} spID3FrameHeaderExtra_V2_3;

typedef struct _spID3FrameHeaderExtra_V2_4 {
    unsigned char group_id;
    unsigned char encryption_method;
    unsigned long data_length_indicator;
} spID3FrameHeaderExtra_V2_4;

typedef struct _spID3FrameHeader {
    char type[4];
    
    unsigned long size;
    unsigned char flag1;
    unsigned char flag2;

    union {
        spID3FrameHeaderExtra_V2_3 v2_3;
        spID3FrameHeaderExtra_V2_4 v2_4;
    } extra;
} spID3FrameHeader;

typedef struct _spID3Frame {
    struct _spID3Frame *parent;
    struct _spID3Frame *child;
    
    struct _spID3Frame *prev;
    struct _spID3Frame *next;

    spFileOffset offset;
    
    spID3FrameHeader header;

    long unsync_count;
} spID3Frame;

typedef struct _spID3Header {
    struct _spID3Frame *parent;        /* NULL */
    struct _spID3Frame *child;
    
    struct _spID3Frame *prev;        /* NULL */
    struct _spID3Frame *next;        /* NULL */

    spFileOffset offset;
    
    spID3FrameHeader header;        /* 'ID3' */

    long unsync_count;
    
    unsigned char version;
    unsigned char revision;

    union {
        spID3HeaderExtra_V2_3 v2_3;
        spID3HeaderExtra_V2_4 v2_4;
    } extra;
} spID3Header;

typedef struct _spID3DataFrame {
    struct _spID3Frame *parent;
    struct _spID3Frame *child;
    
    struct _spID3Frame *prev;
    struct _spID3Frame *next;

    spFileOffset offset;
    
    spID3FrameHeader header;

    long unsync_count;

    unsigned char *data;
} spID3DataFrame;

typedef struct _spID3TextFrame {
    struct _spID3Frame *parent;
    struct _spID3Frame *child;
    
    struct _spID3Frame *prev;
    struct _spID3Frame *next;

    spFileOffset offset;
    
    spID3FrameHeader header;

    long unsync_count;

    unsigned char encoding;
    spBool bom_flag;        /* internal */
    spBool swap_flag;        /* internal */

    unsigned char *string;
} spID3TextFrame;

typedef struct _spID3DescTextFrame {
    struct _spID3Frame *parent;
    struct _spID3Frame *child;
    
    struct _spID3Frame *prev;
    struct _spID3Frame *next;

    spFileOffset offset;
    
    spID3FrameHeader header;

    long unsync_count;

    unsigned char encoding;
    spBool bom_flag;        /* internal */
    spBool swap_flag;        /* internal */

    unsigned char *string;
    unsigned char *actual_string;
} spID3DescTextFrame;

typedef struct _spID3LangTextFrame {
    struct _spID3Frame *parent;
    struct _spID3Frame *child;
    
    struct _spID3Frame *prev;
    struct _spID3Frame *next;

    spFileOffset offset;
    
    spID3FrameHeader header;

    long unsync_count;

    unsigned char encoding;
    spBool bom_flag;        /* internal */
    spBool swap_flag;        /* internal */

    unsigned char *string;
    unsigned char *actual_string;
    
    unsigned char lang[3];
} spID3LangTextFrame;

typedef struct _spID3MimeDataFrame {
    struct _spID3Frame *parent;
    struct _spID3Frame *child;
    
    struct _spID3Frame *prev;
    struct _spID3Frame *next;

    spFileOffset offset;
    
    spID3FrameHeader header;

    long unsync_count;

    unsigned char encoding;
    unsigned char format[3];
    long mime_type_len;
    unsigned char *mime_type;
    long filename_len;
    unsigned char *filename;
    unsigned char data_type;
    long description_len;
    unsigned char *description;

    long data_size;
    unsigned char *data;
} spID3MimeDataFrame;

typedef enum {
    SP_ID3V1_GENRE_EXTENSION_UNKNOWN = -1,
    SP_ID3V1_GENRE_NONEXTENSION = 0,
    SP_ID3V1_GENRE_EXTENSION_WINAMP_CORE = 88,
    SP_ID3V1_GENRE_EXTENSION_WINAMP_1998 = 142,
    SP_ID3V1_GENRE_EXTENSION_WINAMP_2010 = 148,
    SP_ID3V1_GENRE_EXTENSION_END = 191,
} spID3v1GenreExtension;

typedef spID3FrameSize (*spID3FrameUpdateFunc)(spID3Frame *frame, void *data);

extern spBool spInitID3Header(spID3Header *header, unsigned char version, unsigned char revision);
extern void spPropagateID3FrameContentSize(spID3Frame *parent, spChunkSize size_diff);
extern spBool spSetID3FrameContentSize(spID3Frame *frame, spID3FrameSize size, spBool propagate_size);
extern spID3Frame *spCreateID3FrameWithCB(spID3Header *header, const char *type, spID3FrameUpdateFunc update_func, void *data);
extern spID3Frame *spCreateID3Frame(spID3Header *header, const char *type);
    
extern spID3FrameSize spGetID3FrameContentSize(spID3Frame *frame);
extern spID3FrameSize spGetID3FrameSize(spID3Frame *frame, char *string /* char string[5] */);
extern spID3FrameSize spGetID3HeaderSize(spID3Header *header);
extern spID3FrameSize spReadID3Header(spID3Header *header, FILE *fp);
extern spID3FrameSize spWriteID3Header(spID3Header *header, FILE *fp);
extern spBool spFreeID3Header(spID3Header *header);
extern spID3FrameSize spCopyID3Header(spID3Header *dest_header, spID3Header *src_header);

extern spID3Frame *spFindID3FrameFromHeader(spID3Header *header, const char *type);
extern spID3Frame *spFindID3Frame(spID3Frame *frame, const char *type);
    
extern const unsigned char *spGetID3TextFrameString(spID3TextFrame *tframe, unsigned char *encoding);
extern spBool spGetID3TextFrameStringToLocaleCode(spID3TextFrame *tframe, unsigned char *str_in_locale, long size);
extern spBool spGetID3TextFrameTrackNumber(spID3TextFrame *tframe, spLong32 *track, spLong32 *total);
extern spBool spGetID3TextFrameNumber(spID3TextFrame *tframe, spLong32 *number);

extern const unsigned char *spFindID3TextFrameString(spID3Header *header, const char *type, unsigned char *encoding);
extern spBool spFindID3TextFrameStringToLocaleCode(spID3Header *header, const char *type, unsigned char *str_in_locale, long size);
extern spBool spFindID3TextFrameTrackNumber(spID3Header *header, spLong32 *track, spLong32 *total);
extern spBool spFindID3TextFrameDiscNumber(spID3Header *header, spLong32 *disc, spLong32 *total);
extern spBool spFindID3TextFrameTempo(spID3Header *header, spLong32 *tempo);
    
extern spBool spSetID3TextFrameString(spID3TextFrame *tframe, unsigned char encoding, const unsigned char *str, long len);
extern spBool spSetID3TextFrameStringFromLocaleCode(spID3TextFrame *tframe, unsigned char encoding, const unsigned char *str_in_locale);
extern spID3TextFrame *spAppendID3TextFrameStringFromLocaleCode(spID3Header *header, const char *type, spBool find_existing_frame, unsigned char encoding, const unsigned char *str_in_locale);
extern spID3TextFrame *spAppendID3TextFrameString(spID3Header *header, const char *type, spBool find_existing_frame,
                                                  unsigned char encoding, const unsigned char *str, long len);
extern spID3TextFrame *spAppendID3TextFrameTrackNumber(spID3Header *header, spLong32 number, spLong32 total);
extern spID3TextFrame *spAppendID3TextFrameDiscNumber(spID3Header *header, spLong32 number, spLong32 total);
extern spID3TextFrame *spAppendID3TextFrameTempo(spID3Header *header, spLong32 tempo);

extern spBool spParseID3SongInfo(spID3Header *header, spSongInfoV2 *song_info);
extern spBool spAppendID3SongInfo(spID3Header *header, spSongInfoV2 *song_info);
    
extern spBool spIsStringInsideID3AsciiRange(const unsigned char *str);
extern spBool spIsStringInsideID3Laten1Range(const unsigned char *str);

extern void spShowID3HeaderInfo(spID3Header *header);

extern const char *spGetID3v1GenreString(int index, spID3v1GenreExtension *extension_type);
extern int spFindID3v1GenreIndex(const char *string, spID3v1GenreExtension extension_limit);


typedef struct spID3Converter *spID3Converter;

#define SP_ID3_CONVERTER_OPTION_NONE 0L
#define SP_ID3_CONVERTER_OPTION_NO_CODESET_CONVERTER 1L

extern spID3Converter spID3ConverterOpen(const char *system_codeset, unsigned long options);
extern void spID3ConverterClose(spID3Converter id3conv);
extern spBool spID3ConverterFindTextFrameString(spID3Converter id3conv, spID3Header *header, const char *type,
                                                unsigned char *str_in_codeset, long size);
extern spID3TextFrame *spID3ConverterAppendTextFrameString(spID3Converter id3conv, spID3Header *header, const char *type,
                                                           spBool find_existing_frame, unsigned char encoding, const unsigned char *str_in_lang);
extern spBool spID3ConverterParseSongInfo(spID3Converter id3conv, spID3Header *header, spSongInfoV2 *song_info);
extern spBool spID3ConverterAppendSongInfo(spID3Converter id3conv, spID3Header *header, spSongInfoV2 *song_info);
extern void spID3ConverterShowID3HeaderInfo(spID3Converter id3conv, spID3Header *header);
extern spBool spID3ConverterConvertUTF8StringTo(spID3Converter id3conv, unsigned char *iobuf, long buf_size);
extern spBool spID3ConverterConvertToUTF8String(spID3Converter id3conv, unsigned char *iobuf, long buf_size);


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPID3_H */
